/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSDOMApplicationCache_h
#define JSDOMApplicationCache_h


#if ENABLE(OFFLINE_WEB_APPLICATIONS)

#include "JSDOMBinding.h"
#include <kjs/JSGlobalObject.h>
#include <kjs/ObjectPrototype.h>

namespace WebCore {

class DOMApplicationCache;

class JSDOMApplicationCache : public DOMObject {
    typedef DOMObject Base;
public:
    JSDOMApplicationCache(KJS::JSObject* prototype, DOMApplicationCache*);
    virtual ~JSDOMApplicationCache();
    virtual bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    virtual void put(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::JSValue*);
    void putValueProperty(KJS::ExecState*, int, KJS::JSValue*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;

    virtual void mark();

    enum {
        // Attributes
        StatusAttrNum, LengthAttrNum, OncheckingAttrNum, OnerrorAttrNum, 
        OnnoupdateAttrNum, OndownloadingAttrNum, OnprogressAttrNum, OnupdatereadyAttrNum, 
        OncachedAttrNum, 
    };

    // Custom attributes
    KJS::JSValue* onchecking(KJS::ExecState*) const;
    void setOnchecking(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onerror(KJS::ExecState*) const;
    void setOnerror(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onnoupdate(KJS::ExecState*) const;
    void setOnnoupdate(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* ondownloading(KJS::ExecState*) const;
    void setOndownloading(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onprogress(KJS::ExecState*) const;
    void setOnprogress(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onupdateready(KJS::ExecState*) const;
    void setOnupdateready(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* oncached(KJS::ExecState*) const;
    void setOncached(KJS::ExecState*, KJS::JSValue*);

    // Custom functions
    KJS::JSValue* add(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* remove(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* addEventListener(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* removeEventListener(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* dispatchEvent(KJS::ExecState*, const KJS::ArgList&);
    DOMApplicationCache* impl() const { return m_impl.get(); }

private:
    RefPtr<DOMApplicationCache> m_impl;
};

KJS::JSValue* toJS(KJS::ExecState*, DOMApplicationCache*);
DOMApplicationCache* toDOMApplicationCache(KJS::JSValue*);

class JSDOMApplicationCachePrototype : public KJS::JSObject {
public:
    static KJS::JSObject* self(KJS::ExecState*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;
    bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    JSDOMApplicationCachePrototype(KJS::ExecState* exec)
        : KJS::JSObject(exec->lexicalGlobalObject()->objectPrototype()) { }
};

// Functions

KJS::JSValue* jsDOMApplicationCachePrototypeFunctionUpdate(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsDOMApplicationCachePrototypeFunctionSwapCache(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsDOMApplicationCachePrototypeFunctionItem(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsDOMApplicationCachePrototypeFunctionAdd(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsDOMApplicationCachePrototypeFunctionRemove(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsDOMApplicationCachePrototypeFunctionAddEventListener(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsDOMApplicationCachePrototypeFunctionRemoveEventListener(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsDOMApplicationCachePrototypeFunctionDispatchEvent(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
} // namespace WebCore

#endif // ENABLE(OFFLINE_WEB_APPLICATIONS)

#endif
