/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSJavaScriptCallFrame_h
#define JSJavaScriptCallFrame_h

#include "JSDOMBinding.h"
#include <kjs/JSGlobalObject.h>
#include <kjs/ObjectPrototype.h>

namespace WebCore {

class JavaScriptCallFrame;

class JSJavaScriptCallFrame : public DOMObject {
    typedef DOMObject Base;
public:
    JSJavaScriptCallFrame(KJS::JSObject* prototype, JavaScriptCallFrame*);
    virtual ~JSJavaScriptCallFrame();
    virtual bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;

    enum {
        // Attributes
        CallerAttrNum, SourceIdentifierAttrNum, LineAttrNum, ScopeChainAttrNum, 
        ThisObjectAttrNum, FunctionNameAttrNum, TypeAttrNum, 
    };

    // Custom attributes
    KJS::JSValue* scopeChain(KJS::ExecState*) const;
    KJS::JSValue* thisObject(KJS::ExecState*) const;
    KJS::JSValue* type(KJS::ExecState*) const;

    // Custom functions
    KJS::JSValue* evaluate(KJS::ExecState*, const KJS::ArgList&);
    JavaScriptCallFrame* impl() const { return m_impl.get(); }

private:
    RefPtr<JavaScriptCallFrame> m_impl;
};

KJS::JSValue* toJS(KJS::ExecState*, JavaScriptCallFrame*);
JavaScriptCallFrame* toJavaScriptCallFrame(KJS::JSValue*);

class JSJavaScriptCallFramePrototype : public KJS::JSObject {
public:
    static KJS::JSObject* self(KJS::ExecState*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;
    bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    JSJavaScriptCallFramePrototype(KJS::ExecState* exec)
        : KJS::JSObject(exec->lexicalGlobalObject()->objectPrototype()) { }
};

// Functions

KJS::JSValue* jsJavaScriptCallFramePrototypeFunctionEvaluate(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
} // namespace WebCore

#endif
