/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSVGMatrix_h
#define JSSVGMatrix_h


#if ENABLE(SVG)

#include "JSDOMBinding.h"
#include <kjs/JSGlobalObject.h>
#include <kjs/ObjectPrototype.h>
#include "AffineTransform.h"
#include "JSSVGPODTypeWrapper.h"

namespace WebCore {

class JSSVGMatrix : public DOMObject {
    typedef DOMObject Base;
public:
    JSSVGMatrix(KJS::JSObject* prototype, JSSVGPODTypeWrapper<AffineTransform>*, SVGElement* context);
    virtual ~JSSVGMatrix();
    virtual bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    virtual void put(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::JSValue*);
    void putValueProperty(KJS::ExecState*, int, KJS::JSValue*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;

    enum {
        // Attributes
        AAttrNum, BAttrNum, CAttrNum, DAttrNum, 
        EAttrNum, FAttrNum, 
    };

    // Custom functions
    KJS::JSValue* multiply(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* inverse(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* translate(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* scale(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* scaleNonUniform(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* rotate(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* rotateFromVector(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* flipX(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* flipY(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* skewX(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* skewY(KJS::ExecState*, const KJS::ArgList&);
    JSSVGPODTypeWrapper<AffineTransform>* impl() const { return m_impl.get(); }
    SVGElement* context() const { return m_context.get(); }

private:
    RefPtr<SVGElement> m_context;
    RefPtr<JSSVGPODTypeWrapper<AffineTransform> > m_impl;
};

KJS::JSValue* toJS(KJS::ExecState*, JSSVGPODTypeWrapper<AffineTransform>*, SVGElement* context);
AffineTransform toSVGMatrix(KJS::JSValue*);

class JSSVGMatrixPrototype : public KJS::JSObject {
public:
    static KJS::JSObject* self(KJS::ExecState*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;
    bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    JSSVGMatrixPrototype(KJS::ExecState* exec)
        : KJS::JSObject(exec->lexicalGlobalObject()->objectPrototype()) { }
};

// Functions

KJS::JSValue* jsSVGMatrixPrototypeFunctionMultiply(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionInverse(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionTranslate(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionScale(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionScaleNonUniform(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionRotate(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionRotateFromVector(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionFlipX(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionFlipY(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionSkewX(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGMatrixPrototypeFunctionSkewY(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
} // namespace WebCore

#endif // ENABLE(SVG)

#endif
