/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSVGPointList_h
#define JSSVGPointList_h


#if ENABLE(SVG)

#include "JSDOMBinding.h"
#include <kjs/JSGlobalObject.h>
#include <kjs/ObjectPrototype.h>

namespace WebCore {

class SVGPointList;

class JSSVGPointList : public DOMObject {
    typedef DOMObject Base;
public:
    JSSVGPointList(KJS::JSObject* prototype, SVGPointList*, SVGElement* context);
    virtual ~JSSVGPointList();
    virtual bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;

    enum {
        // Attributes
        NumberOfItemsAttrNum, 
    };

    // Custom functions
    KJS::JSValue* clear(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* initialize(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* getItem(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* insertItemBefore(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* replaceItem(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* removeItem(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* appendItem(KJS::ExecState*, const KJS::ArgList&);
    SVGPointList* impl() const { return m_impl.get(); }
    SVGElement* context() const { return m_context.get(); }

private:
    RefPtr<SVGElement> m_context;
    RefPtr<SVGPointList > m_impl;
};

KJS::JSValue* toJS(KJS::ExecState*, SVGPointList*, SVGElement* context);
SVGPointList* toSVGPointList(KJS::JSValue*);

class JSSVGPointListPrototype : public KJS::JSObject {
public:
    static KJS::JSObject* self(KJS::ExecState*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;
    bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    JSSVGPointListPrototype(KJS::ExecState* exec)
        : KJS::JSObject(exec->lexicalGlobalObject()->objectPrototype()) { }
};

// Functions

KJS::JSValue* jsSVGPointListPrototypeFunctionClear(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGPointListPrototypeFunctionInitialize(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGPointListPrototypeFunctionGetItem(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGPointListPrototypeFunctionInsertItemBefore(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGPointListPrototypeFunctionReplaceItem(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGPointListPrototypeFunctionRemoveItem(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGPointListPrototypeFunctionAppendItem(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
} // namespace WebCore

#endif // ENABLE(SVG)

#endif
