/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSSVGSVGElement_h
#define JSSVGSVGElement_h


#if ENABLE(SVG)

#include "JSSVGElement.h"

namespace WebCore {

class SVGSVGElement;

class JSSVGSVGElement : public JSSVGElement {
    typedef JSSVGElement Base;
public:
    JSSVGSVGElement(KJS::JSObject* prototype, SVGSVGElement*);
    virtual bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    virtual void put(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::JSValue*);
    void putValueProperty(KJS::ExecState*, int, KJS::JSValue*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;

    enum {
        // Attributes
        XAttrNum, YAttrNum, WidthAttrNum, HeightAttrNum, 
        ContentScriptTypeAttrNum, ContentStyleTypeAttrNum, ViewportAttrNum, PixelUnitToMillimeterXAttrNum, 
        PixelUnitToMillimeterYAttrNum, ScreenPixelToMillimeterXAttrNum, ScreenPixelToMillimeterYAttrNum, UseCurrentViewAttrNum, 
        CurrentScaleAttrNum, CurrentTranslateAttrNum, RequiredFeaturesAttrNum, RequiredExtensionsAttrNum, 
        SystemLanguageAttrNum, XmllangAttrNum, XmlspaceAttrNum, ExternalResourcesRequiredAttrNum, 
        ClassNameAttrNum, StyleAttrNum, NearestViewportElementAttrNum, FarthestViewportElementAttrNum, 
        ViewBoxAttrNum, PreserveAspectRatioAttrNum, ZoomAndPanAttrNum, 
    };
};


class JSSVGSVGElementPrototype : public KJS::JSObject {
public:
    static KJS::JSObject* self(KJS::ExecState*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;
    bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    JSSVGSVGElementPrototype(KJS::ExecState* exec)
        : KJS::JSObject(JSSVGElementPrototype::self(exec)) { }
};

// Functions

KJS::JSValue* jsSVGSVGElementPrototypeFunctionSuspendRedraw(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionUnsuspendRedraw(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionUnsuspendRedrawAll(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionForceRedraw(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionPauseAnimations(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionUnpauseAnimations(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionAnimationsPaused(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetCurrentTime(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionSetCurrentTime(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetIntersectionList(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetEnclosureList(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCheckIntersection(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCheckEnclosure(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionDeselectAll(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGNumber(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGLength(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGAngle(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGPoint(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGMatrix(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGRect(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGTransform(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionCreateSVGTransformFromMatrix(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionHasExtension(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetPresentationAttribute(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetBBox(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetCTM(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetScreenCTM(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsSVGSVGElementPrototypeFunctionGetTransformToElement(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
} // namespace WebCore

#endif // ENABLE(SVG)

#endif
