/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSXMLHttpRequestUpload_h
#define JSXMLHttpRequestUpload_h

#include "JSDOMBinding.h"
#include <kjs/JSGlobalObject.h>
#include <kjs/ObjectPrototype.h>

namespace WebCore {

class XMLHttpRequestUpload;

class JSXMLHttpRequestUpload : public DOMObject {
    typedef DOMObject Base;
public:
    JSXMLHttpRequestUpload(KJS::JSObject* prototype, XMLHttpRequestUpload*);
    virtual ~JSXMLHttpRequestUpload();
    virtual bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    virtual void put(KJS::ExecState*, const KJS::Identifier& propertyName, KJS::JSValue*);
    void putValueProperty(KJS::ExecState*, int, KJS::JSValue*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;

    virtual void mark();

    static KJS::JSValue* getConstructor(KJS::ExecState*);
    enum {
        // Attributes
        OnabortAttrNum, OnerrorAttrNum, OnloadAttrNum, OnloadstartAttrNum, 
        OnprogressAttrNum, 

        // The Constructor Attribute
        ConstructorAttrNum
    };

    // Custom attributes
    KJS::JSValue* onabort(KJS::ExecState*) const;
    void setOnabort(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onerror(KJS::ExecState*) const;
    void setOnerror(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onload(KJS::ExecState*) const;
    void setOnload(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onloadstart(KJS::ExecState*) const;
    void setOnloadstart(KJS::ExecState*, KJS::JSValue*);
    KJS::JSValue* onprogress(KJS::ExecState*) const;
    void setOnprogress(KJS::ExecState*, KJS::JSValue*);

    // Custom functions
    KJS::JSValue* addEventListener(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* removeEventListener(KJS::ExecState*, const KJS::ArgList&);
    KJS::JSValue* dispatchEvent(KJS::ExecState*, const KJS::ArgList&);
    XMLHttpRequestUpload* impl() const { return m_impl.get(); }

private:
    RefPtr<XMLHttpRequestUpload> m_impl;
};

KJS::JSValue* toJS(KJS::ExecState*, XMLHttpRequestUpload*);
XMLHttpRequestUpload* toXMLHttpRequestUpload(KJS::JSValue*);

class JSXMLHttpRequestUploadPrototype : public KJS::JSObject {
public:
    static KJS::JSObject* self(KJS::ExecState*);
    virtual const KJS::ClassInfo* classInfo() const { return &s_info; }
    static const KJS::ClassInfo s_info;
    bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    JSXMLHttpRequestUploadPrototype(KJS::ExecState* exec)
        : KJS::JSObject(exec->lexicalGlobalObject()->objectPrototype()) { }
};

// Functions

KJS::JSValue* jsXMLHttpRequestUploadPrototypeFunctionAddEventListener(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsXMLHttpRequestUploadPrototypeFunctionRemoveEventListener(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
KJS::JSValue* jsXMLHttpRequestUploadPrototypeFunctionDispatchEvent(KJS::ExecState*, KJS::JSObject*, KJS::JSValue*, const KJS::ArgList&);
} // namespace WebCore

#endif
