/*
 * This file is part of the DOM implementation for KDE.
 *
 * Copyright (C) 2003 Lars Knoll (knoll@kde.org)
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

/* This file is mostly data generated by flex. Unfortunately flex
   can't handle 16bit strings directly, so we just copy the part of
   the code we need and modify it to our needs.

   Most of the defines below are to make sure we can easily use the
   flex generated code, using as little editing as possible.

   The flex syntax to generate the lexer are more or less directly
   copied from the CSS2.1 specs, with some fixes for comments and
   the important symbol.

   To regenerate, run flex on tokenizer.flex. After this, copy the
   data tables and the YY_DECL method over to this file. Remove the
   init code from YY_DECL and change the YY_END_OF_BUFFER to only call
   yyterminate().

*/

// --------- begin generated code -------------------


#include "CSSGrammar.h"

#define INITIAL 0
#define mediaquery 1
#define forkeyword 2

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined __STDC_VERSION__ && __STDC_VERSION__ >= 199901L
#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t;
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */
#define YY_NUM_RULES 66
#define YY_END_OF_BUFFER 67
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[470] =
    {   0,
        0,    0,    0,    0,    0,    0,   67,   65,    2,    2,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   54,
       65,   65,   65,   65,   15,   15,   15,   65,   65,   64,
       15,   15,   15,   63,   15,    2,    0,    0,    0,   14,
        0,    0,    0,    0,   18,   18,    8,    0,    0,    9,
        0,    0,    0,   15,   15,   15,   55,    0,   53,    0,
        0,   54,    0,   52,   52,   52,   52,   52,   52,   52,
       52,   52,   52,   16,   52,   52,   49,    0,    0,    0,
       34,   34,   34,   34,   34,   34,   34,   15,   15,    7,
       60,   15,    0,    0,   15,   15,    0,   15,    6,    5,

       15,   15,   15,   15,    0,    0,    0,   14,    0,    0,
        0,   18,   18,   18,    0,   18,    0,    0,   14,    0,
        0,    4,   16,   15,    0,    0,   52,   52,   52,    0,
       52,   40,   52,   36,   38,   52,   50,   42,   52,   41,
       48,   52,   44,   43,   39,   52,    0,   34,   34,   34,
       34,    0,   34,   34,   34,   34,   34,   34,   15,   15,
       15,   16,   15,   15,   61,   61,   15,   12,   10,   15,
       13,    0,    0,    0,   17,   18,   18,   18,   17,    0,
        0,   15,    0,    1,   52,   52,   52,   52,   45,   52,
       51,   16,   46,    3,   34,   34,   34,   34,   34,   34,

       34,   34,   34,   34,   15,   15,   56,    0,   61,   61,
       61,   60,   11,    0,    0,    0,   18,   18,   18,    0,
       15,    0,    0,   52,   52,   52,   47,   34,   34,   34,
       34,   34,   34,   34,   34,   20,   15,   15,   62,   61,
       61,   61,   61,    0,    0,    0,    0,   58,    0,    0,
        0,    0,   18,   18,   18,    0,   15,   52,   52,   37,
       34,   34,   34,   34,   34,   34,   21,   34,   15,   15,
       62,   61,   61,   61,   61,   61,    0,    0,    0,    0,
        0,    0,    0,    0,    0,   58,    0,    0,    0,    0,
       17,   18,   18,   17,    0,   15,   52,   52,   34,   34,

       34,   34,   34,   19,   34,   15,   15,   62,   61,   61,
       61,   61,   61,   61,    0,   57,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,   18,
       18,    0,   15,   52,   52,   34,   34,   34,   23,   34,
       34,   15,   62,   61,   61,   61,   61,   61,   61,   61,
        0,   57,    0,    0,    0,   57,    0,    0,    0,    0,
       18,   15,   52,   34,   34,   34,   34,   62,    0,    0,
        0,   35,   15,   34,   34,   34,   34,   34,   34,   22,
       24,   62,    0,    0,    0,   15,   34,   34,   34,   34,
       34,   34,    0,    0,    0,   60,   34,   34,   34,   34,

       34,   34,   34,   34,    0,    0,    0,    0,    0,    0,
       34,   34,   34,   34,   25,   34,   34,   34,    0,    0,
        0,   59,    0,    0,   26,   34,   34,   34,   34,   27,
       34,    0,    0,    0,    0,   31,   34,   34,   34,   34,
        0,    0,    0,   34,   34,   34,   34,    0,    0,   34,
       34,   29,   34,    0,    0,   33,   34,   30,    0,    0,
       28,   34,    0,   34,   34,   34,   34,   32,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    4,    5,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    6,    7,    8,    9,   10,   11,   12,   13,   14,
       15,   16,   17,   12,   18,   19,   20,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   12,   22,   23,
       24,   25,   26,   27,   31,   32,   33,   34,   35,   36,
       37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
       47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
       12,   28,   12,   29,   30,   12,   31,   32,   33,   34,

       35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
       45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
       55,   56,   57,   58,   12,   59,    1,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,

       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60
    } ;

static yyconst flex_int32_t yy_meta[61] =
    {   0,
        1,    2,    3,    3,    3,    4,    5,    5,    5,    5,
        5,    5,    5,    6,    7,    5,    5,    8,    5,    5,
        9,    5,    5,    5,    5,   10,    5,   11,    5,   11,
       12,   12,   12,   12,   12,   12,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,    5,    5,    5,   11
    } ;

static yyconst flex_int16_t yy_base[508] =
    {   0,
        0,    0,   39,   41, 1608, 1599, 1634, 2351,   62,   71,
       76,   61,   69, 1609,   78, 1607,   89, 1608, 1612,  132,
     1613,   91,  123, 1594,   80,  104,   97, 1592, 1591, 2351,
       85,  176,  175, 2351,  177,  193,  204, 1571,   84, 2351,
      242,  110,  180,  196, 1585,  205, 2351,  113,  277, 2351,
     1587,   72,  221,  133,  206,  234,  181, 1588, 1592, 1574,
     1574,    0,  268,  118, 1566,  221,   60,  240,   92,  230,
       95,  223,  244,  267,  238,  286, 1565, 1573,  278,  294,
     1561,  269,  190,  290,  232,  288,  292,  307,  334, 2351,
     2351,  318,  340, 1567,  328,  329,  356,  336, 2351, 2351,

      366,  331,  369,  370, 1541,  393,  316,  326,  420,  455,
      372, 1544,  490, 1543,  381,  398,  382,  407,  414,  525,
      560, 2351,  334,  433, 1553,  420, 1523,  595, 1522,  446,
      294, 1515,   34, 1507, 1496,  332, 1495, 1494,  330, 1493,
     1492,  416, 1491, 1472, 1462,  231, 1466,  410, 1453,  630,
     1452,  481,  415,  108,  422,  319,  421,  434,  516,  456,
      665, 1458,  554,  471,  448, 1438,  490,  491,  492,  552,
      526, 1404,  527,  621,  656,  672, 1418,  707,  698,  556,
      714,  562, 1429, 2351,  723, 1413,  758,  472, 1402,  441,
     1399,  480, 1379, 2351,  504,  749, 1370,  793,  539,  555,

      544,  470,  475,  506,  784,  800, 2351,  809,  552, 1367,
     1354,  609,  557, 1319,  816,  825,  832,  841,  848,  857,
      611, 1349,  523,  864,  873,  576, 1335,  580,  880,  889,
      592,  381,  558,  514,  610, 1321,  896,  905,  912,  584,
     1297, 1289, 1281,  947,  961,  632,  666, 2351,  988, 1249,
      947,  979,  996, 1004, 1012, 1020,  667, 1028, 1036, 1252,
      505, 1044, 1052,  645,  646,  674, 1212,  690, 1060, 1068,
     1076,  657, 1197, 1185, 1126, 1064,  763,  743,  771, 1111,
      709, 1146, 1125, 1158, 1185, 1199, 1226, 1261, 1051, 1185,
     2351, 1217, 1252, 1046, 1269,  794, 1277, 1285,  759, 1293,

     1301,  760,  546, 1038,  615, 1336, 1322, 1338,  658, 1032,
     1024, 1016,  972,  931,  798, 2351,  969,  744, 1373, 1400,
     1435,  958,  810, 1381, 1470, 1505, 1379,  842, 1426, 1240,
     1461, 1496,  956, 1414, 1513,  697, 1420, 1521,  779,  616,
      688, 1556, 1542,  705, 2351, 2351, 2351, 2351, 2351, 2351,
     1577,  926,  977, 1565, 1604,  826,  842, 1590, 1606,  664,
     1449,  928, 1483, 1602, 1562,  650,  692, 1625, 1631, 1647,
     1653, 2351,  959,  960,  971, 1070,  907, 1089,  617,  644,
      619, 2351, 1669, 1675, 1691,  990, 1090,  698, 1107, 1078,
     1094, 1127, 1697, 1713, 1719, 1754, 1126, 1137,  998, 1144,

     1157, 1180, 1106, 1156, 1742, 1758, 1781, 1342, 1779, 1801,
     1109,  843, 1207, 1166,  590,  778, 1198, 1168, 1815, 1842,
     1510, 2351, 1821, 1819,  581, 1242, 1194, 1209, 1302,  551,
     1093, 1856, 1858, 1893, 1920,  469,  875, 1338,  874, 1128,
     1879, 1901, 1899, 1243, 1244, 1303, 1333, 1926, 1942, 1401,
     1334,  445, 1416, 1948, 1964,  444, 1181, 1263, 1970, 1986,
      411, 1363, 1992, 1364, 1362, 1182, 1450,  263, 2351, 2027,
     2032, 2043, 2048, 2053, 2062, 2069, 2080, 2089, 2094, 2105,
     2117, 2119, 2128, 2133, 2142, 2147, 2156, 2165, 2177, 2186,
     2195, 2200, 2212, 2217, 2228, 2233, 2244, 2255, 2266, 2271,

     2282, 2293, 2298, 2309, 2318, 2329, 2338
    } ;

static yyconst flex_int16_t yy_def[508] =
    {   0,
      469,    1,    1,    1,    1,    1,  469,  469,  469,  469,
      469,  470,  471,  469,  472,  469,  473,  469,  469,  469,
      469,  474,  475,  469,  476,  476,  476,  469,  469,  469,
      476,  476,  476,  469,  476,  469,  469,  469,  470,  469,
      477,  471,  469,  478,  479,  479,  469,  472,  480,  469,
      469,  469,  475,  476,  476,  476,   20,  481,  469,  482,
      469,   20,  483,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  469,  474,  485,
      486,  486,  486,  486,  486,  486,  486,  476,  476,  469,
      469,  476,  487,  469,  476,  476,  469,  476,  469,  469,

      476,  476,  476,  476,  469,  470,  470,  470,  470,  477,
      469,  479,   46,  479,  488,   46,  472,  472,  472,  472,
      480,  469,  469,  476,  481,  489,  484,  484,  484,  490,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  469,  486,  486,  486,
      486,  491,  486,  486,  486,  486,  486,  486,   89,  476,
       89,  469,  476,  476,  492,  469,  476,  476,  476,  476,
      476,  469,  470,  109,  469,  113,  479,  113,   46,  472,
      120,  476,  493,  469,  128,  484,  128,  484,  484,  484,
      484,  484,  484,  469,  486,  150,  486,  150,  486,  486,

      486,  486,  486,  486,   89,  161,  469,  469,  494,  469,
      469,  495,  476,  469,  109,  469,  113,  178,   46,  120,
      476,  493,  489,  128,  187,  484,  484,  486,  150,  198,
      486,  486,  486,  486,  486,  486,   89,  161,  469,  496,
      469,  469,  469,  495,  495,  497,  498,  469,  499,  469,
      109,  469,  113,  178,   46,  120,  476,  128,  187,  484,
      486,  150,  198,  486,  486,  486,  486,  486,   89,  161,
      469,  500,  469,  469,  469,  469,  469,  497,  469,  501,
      498,  502,  495,  495,  495,  495,  495,  499,  469,  109,
      469,  113,  178,  479,  120,  476,  128,  187,  486,  150,

      198,  486,  486,  486,  486,  476,  161,  469,  503,  469,
      469,  469,  469,  469,  469,  469,  497,  497,  497,  497,
      501,  498,  498,  498,  498,  502,  287,  469,  109,  479,
      178,  120,  476,  484,  187,  486,  486,  198,  486,  486,
      486,  476,  469,  469,  469,  469,  469,  469,  469,  469,
      497,  497,  497,  320,  498,  498,  498,  325,  287,  469,
      479,  476,  484,  486,  486,  486,  486,  469,  320,  325,
      287,  469,  476,  486,  486,  486,  486,  486,  486,  486,
      486,  469,  320,  325,  287,  476,  486,  486,  486,  486,
      486,  486,  320,  325,  287,  504,  486,  486,  486,  486,

      486,  486,  486,  486,  320,  325,  504,  407,  505,  506,
      486,  486,  486,  486,  486,  486,  486,  486,  506,  506,
      469,  469,  506,  507,  486,  486,  486,  486,  486,  486,
      486,  506,  420,  506,  420,  486,  486,  486,  486,  486,
      420,  506,  435,  486,  486,  486,  486,  420,  435,  486,
      486,  486,  486,  420,  435,  486,  486,  486,  420,  435,
      486,  486,  435,  486,  486,  486,  486,  486,    0,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,

      469,  469,  469,  469,  469,  469,  469
    } ;

static yyconst flex_int16_t yy_nxt[2412] =
    {   0,
        8,    9,   10,    9,    9,    9,   11,   12,   13,   14,
        8,    8,   15,    8,    8,   16,    8,   17,   18,   19,
       20,    8,   21,    8,    8,    8,   22,   23,   24,   25,
       25,   25,   25,   25,   25,   25,   25,   25,   25,   25,
       25,   25,   25,   26,   25,   25,   25,   25,   25,   25,
       27,   25,   25,   25,   25,   25,    8,   28,   29,   25,
       30,  130,   30,   36,   36,   36,   36,   36,   40,   31,
      189,   31,   36,   36,   36,   36,   36,   37,   37,   37,
       37,   37,   32,   33,   32,   33,   42,  130,   41,   43,
       40,   40,   52,   91,  133,   34,   44,   34,   91,   46,

       46,   46,   46,   46,   46,   49,   51,   93,   79,   52,
       91,   41,   93,   97,   38,  123,   53,   91,   80,  130,
       94,   95,  130,   82,   93,   40,   83,  469,  101,   84,
      469,   93,   55,   85,   86,  152,   87,   44,  138,  136,
       49,   56,   59,   89,   98,  130,   91,  131,   96,   60,
       61,  200,   62,   89,   89,   89,   89,   89,   89,   63,
       93,   64,   65,   65,   66,   67,   68,   65,   69,   70,
       71,   65,   72,   65,   73,   74,   65,   75,   65,   76,
       77,   65,   65,   65,   65,   65,   65,   65,   91,   91,
       91,   65,   94,   95,   36,   36,   36,   36,   36,  469,

      111,   57,   93,   93,   93,   37,   37,   37,   37,   37,
      111,  111,  111,  111,  111,  111,  113,  152,  103,   91,
      102,  104,   94,   95,   65,  116,  113,  113,  113,  113,
      113,  113,  115,   93,  154,  116,  116,  116,  116,  116,
      116,   89,   38,   39,   39,   39,  106,   91,  130,  108,
      130,   89,   89,   89,   89,   89,   89,  130,  130,  152,
      139,   93,  109,  132,  193,  130,  156,  130,  124,  110,
      143,  130,  109,  109,  109,  109,  109,  109,   48,   48,
       48,  117,  134,   94,  142,  137,  140,  144,  128,  119,
      152,  145,  141,  135,  130,  469,  152,  120,  128,  128,

      128,  128,  128,  128,  121,   80,  153,  120,  120,  120,
      120,  120,  120,  130,  150,  152,  146,  152,  157,  152,
       91,  130,  158,   40,  150,  150,  150,  150,  150,  150,
      148,   91,  155,   40,   93,   88,   88,   88,   88,   88,
      188,   91,   91,   41,   91,   93,  152,   91,  163,   91,
       94,   94,  202,   41,  159,   93,   93,  130,   93,  130,
      161,   93,  190,   93,  159,  159,  159,  159,  159,  159,
      161,  161,  161,  161,  161,  161,  165,  167,  164,   91,
      169,  166,   91,   91,   48,  191,  165,  165,  165,  165,
      165,  165,  175,   93,   40,   39,   93,   93,  265,  168,

       40,  178,  175,  175,  175,  175,  175,  175,  152,   49,
      170,  178,  178,  178,  178,  178,  178,  171,  179,   40,
       41,  107,  173,  173,  173,  107,   40,   40,  179,  179,
      179,  179,  179,  179,   49,  126,  192,  152,  152,  184,
      174,   49,  152,  130,  195,  199,   91,   41,  152,  152,
      174,  174,  174,  174,  174,  174,   39,   39,   39,  106,
       93,  152,  108,  203,  182,  208,  187,  201,  130,   91,
      204,  152,  152,  210,  227,  109,  187,  187,  187,  187,
      187,  187,  110,   93,  207,  109,  109,  109,  109,  109,
      109,  112,  112,  112,  112,  112,  152,  152,   93,  130,

      192,  198,  152,  212,   91,  207,  226,  130,  234,  235,
      176,  198,  198,  198,  198,  198,  198,   93,   93,   93,
      176,  176,  176,  176,  176,  176,  118,  180,  180,  180,
      118,  152,  152,  152,   40,  228,  205,   40,  223,   91,
      236,  152,  184,  299,  267,  181,  205,  205,  205,  205,
      205,  205,   49,   93,   41,  181,  181,  181,  181,  181,
      181,   48,   48,   48,  117,   91,  152,   91,   40,  208,
       91,  152,  119,  152,  163,   91,  340,  241,  152,   93,
      120,   93,  152,   49,   93,  152,  231,  121,  233,   93,
      120,  120,  120,  120,  120,  120,  127,  127,  127,  127,

      127,  208,  221,  130,  232,  266,  213,  152,  152,  273,
      244,  244,  244,  244,  244,  185,  246,  152,  260,  152,
      261,  247,  130,  248,   91,  185,  185,  185,  185,  185,
      185,  149,  149,  149,  149,  149,  249,  152,   93,  279,
      264,  215,  152,  152,  152,  341,  152,  392,  366,  257,
      196,  215,  215,  215,  215,  215,  215,  152,  268,  280,
      196,  196,  196,  196,  196,  196,  160,  160,  160,  160,
      160,  152,  152,  152,  208,  208,  216,  152,  279,  302,
       91,  303,  310,  345,  380,  206,  216,  216,  216,  216,
      216,  216,  217,  282,   93,  206,  206,  206,  206,  206,

      206,  152,  217,  217,  217,  217,  217,  217,  177,  177,
      177,  177,  177,  372,  364,  152,  296,  152,  219,  152,
      367,  279,  208,  304,  152,  152,  381,  218,  219,  219,
      219,  219,  219,  219,  220,  305,  282,  218,  218,  218,
      218,  218,  218,  224,  220,  220,  220,  220,  220,  220,
      279,  279,  399,  224,  224,  224,  224,  224,  224,  186,
      186,  186,  186,  186,  277,  277,  277,  277,  277,  229,
      280,  280,  315,  315,  315,  315,  315,  248,  225,  229,
      229,  229,  229,  229,  229,  316,  152,  152,  225,  225,
      225,  225,  225,  225,  197,  197,  197,  197,  197,  315,

      315,  315,  315,  315,  237,  152,  152,   91,  336,  339,
      429,  333,  316,  230,  237,  237,  237,  237,  237,  237,
      238,   93,  279,  230,  230,  230,  230,  230,  230,  239,
      238,  238,  238,  238,  238,  238,  251,  282,  279,  239,
      239,  239,  239,  239,  239,  252,  251,  251,  251,  251,
      251,  251,  253,  282,  279,  252,  252,  252,  252,  252,
      252,  254,  253,  253,  253,  253,  253,  253,  255,  282,
      152,  254,  254,  254,  254,  254,  254,  256,  255,  255,
      255,  255,  255,  255,  258,  360,  426,  256,  256,  256,
      256,  256,  256,  259,  258,  258,  258,  258,  258,  258,

      262,  152,  152,  259,  259,  259,  259,  259,  259,  263,
      262,  262,  262,  262,  262,  262,  269,  444,  446,  263,
      263,  263,  263,  263,  263,  270,  269,  269,  269,  269,
      269,  269,  271,  279,  152,  270,  270,  270,  270,  270,
      270,   91,  271,  271,  271,  271,  271,  271,  244,  244,
      244,  244,  244,  280,  246,   93,  350,  390,  373,  247,
      281,  248,  277,  277,  277,  277,  277,  290,  469,   91,
      279,  278,   91,  469,  249,  248,  279,  290,  290,  290,
      290,  290,  290,   93,  279,  282,   93,  152,  249,  277,
      277,  277,  277,  283,  387,  285,  280,  349,  152,  291,

      285,  285,  286,  396,  280,  388,  386,  362,  287,  291,
      291,  291,  291,  291,  291,  288,  292,   93,  287,  287,
      287,  287,  287,  287,  293,  152,  292,  292,  292,  292,
      292,  292,  294,  413,  293,  293,  293,  293,  293,  293,
      295,  348,  294,  294,  294,  294,  294,  294,  297,  347,
      295,  295,  295,  295,  295,  295,  298,  346,  297,  297,
      297,  297,  297,  297,  300,  152,  298,  298,  298,  298,
      298,  298,  301,  115,  300,  300,  300,  300,  300,  300,
      306,  328,  301,  301,  301,  301,  301,  301,  307,  314,
      306,  306,  306,  306,  306,  306,  308,  152,  307,  307,

      307,  307,  307,  307,  389,  152,  308,  308,  308,  308,
      308,  308,  278,  278,  278,  317,  152,  152,  319,  401,
      152,  152,  397,  391,  440,  398,  277,  277,  277,  277,
      277,  320,  469,  152,  152,  402,  152,  469,  321,  248,
      400,  320,  320,  320,  320,  320,  320,  281,  281,  281,
      322,  313,  249,  152,  152,  152,  417,  425,  324,  277,
      277,  277,  277,  277,  152,  469,  325,  411,  403,  447,
      469,  152,  248,  326,  404,  412,  325,  325,  325,  325,
      325,  325,  414,  152,  152,  249,  277,  277,  277,  277,
      277,  415,  469,  152,  418,  152,  428,  469,  431,  248,

      277,  277,  277,  277,  277,  329,  469,  152,  152,  152,
      312,  469,  249,  248,  416,  329,  329,  329,  329,  329,
      329,  152,  311,  467,  437,  152,  249,  283,  283,  283,
      283,  283,  430,  469,  152,  461,  152,  330,  469,  152,
      248,  112,  112,  112,  112,  112,  327,  330,  330,  330,
      330,  330,  330,  249,  427,  438,  327,  327,  327,  327,
      327,  327,  277,  277,  277,  277,  283,  115,  285,  152,
      152,  152,  331,  285,  285,  286,  436,  450,  451,  130,
      462,  287,  331,  331,  331,  331,  331,  331,  288,  332,
      152,  287,  287,  287,  287,  287,  287,  334,  289,  332,

      332,  332,  332,  332,  332,  335,  276,  334,  334,  334,
      334,  334,  334,  337,  275,  335,  335,  335,  335,  335,
      335,  338,  274,  337,  337,  337,  337,  337,  337,  152,
      152,  338,  338,  338,  338,  338,  338,   88,   88,   88,
       88,   88,  342,  469,  469,  469,  469,  469,  152,   91,
      452,  439,  342,  342,  342,  342,  342,  342,  343,  469,
      152,  152,  130,   93,  223,  152,  250,  453,  343,  343,
      343,  343,  343,  343,  351,  315,  315,  315,  351,  243,
      279,  457,  355,  315,  315,  315,  355,  352,  445,  152,
      152,  152,  242,  279,  466,  356,  464,  152,  465,  359,

      280,  318,  353,  353,  353,  318,  130,  279,  282,  359,
      359,  359,  359,  359,  359,  127,  127,  127,  127,  127,
      354,  149,  149,  149,  149,  149,  130,  280,  152,  130,
      354,  354,  354,  354,  354,  354,  278,  278,  278,  317,
      130,  130,  319,  152,  223,  115,   39,  152,  214,  456,
      177,  177,  177,  177,  177,  320,   39,   39,   39,   39,
       39,   39,  321,  211,  458,  320,  320,  320,  320,  320,
      320,  323,  357,  357,  357,  323,  115,  152,  162,  152,
      152,  361,  279,  194,  186,  186,  186,  186,  186,  130,
      358,  361,  361,  361,  361,  361,  361,  282,  468,  130,

      358,  358,  358,  358,  358,  358,  281,  281,  281,  322,
      130,  421,  421,  421,  421,  421,   48,  324,  130,  130,
      130,  130,  130,  130,  422,  325,   48,   48,   48,   48,
       48,   48,  326,  363,  130,  325,  325,  325,  325,  325,
      325,  365,  130,  363,  363,  363,  363,  363,  363,  130,
      130,  365,  365,  365,  365,  365,  365,  160,  160,  160,
      160,  160,  368,  197,  197,  197,  197,  197,  126,   91,
      115,  115,  368,  368,  368,  368,  368,  368,  351,  315,
      315,  315,  351,   93,  279,  369,  172,  162,  152,  152,
      147,  352,  130,  130,   57,  369,  369,  369,  369,  369,

      369,   63,   59,  126,  280,  355,  315,  315,  315,  355,
      370,  122,  115,  105,  100,   99,  279,   90,  356,   78,
      370,  370,  370,  370,  370,  370,  371,   58,   57,  152,
       50,  282,   47,  469,   35,  374,  371,  371,  371,  371,
      371,  371,  375,   35,  376,  382,  469,  469,  469,  377,
      378,  383,  469,  379,  469,  382,  382,  382,  382,  382,
      382,  383,  383,  383,  383,  383,  383,  384,  469,  469,
      469,  469,  469,  385,  469,  469,  469,  384,  384,  384,
      384,  384,  384,  385,  385,  385,  385,  385,  385,  393,
      469,  469,  469,  469,  469,  394,  469,  469,  469,  393,

      393,  393,  393,  393,  393,  394,  394,  394,  394,  394,
      394,  395,  469,  469,  469,  469,  469,  405,  469,  469,
      469,  395,  395,  395,  395,  395,  395,  405,  405,  405,
      405,  405,  405,  406,  469,  469,  469,  469,  469,  245,
      469,  469,  469,  406,  406,  406,  406,  406,  406,  245,
      245,  245,  245,  245,  245,  407,  407,  407,  407,  407,
      469,  469,  278,  469,  469,  469,  469,  469,  469,  469,
      469,  408,  278,  278,  278,  278,  278,  278,  281,  469,
      469,  409,  407,  407,  407,  407,  407,  469,  281,  281,
      281,  281,  281,  281,  469,  469,  469,  469,  408,  420,

      469,  469,  421,  421,  421,  421,  421,  469,  409,  420,
      420,  420,  420,  420,  420,  422,  421,  421,  421,  421,
      421,  469,  421,  421,  421,  421,  421,  469,  424,  422,
      469,  469,  469,  469,  469,  422,  469,  469,  469,  435,
      469,  469,  424,  432,  432,  432,  432,  432,  424,  435,
      435,  435,  435,  435,  435,  469,  422,  421,  421,  421,
      421,  421,  433,  469,  469,  469,  469,  469,  469,  424,
      422,  469,  433,  433,  433,  433,  433,  433,  441,  469,
      469,  469,  469,  424,  469,  469,  469,  469,  441,  441,
      441,  441,  441,  441,  421,  421,  421,  421,  421,  448,

      469,  469,  421,  421,  421,  421,  421,  422,  469,  448,
      448,  448,  448,  448,  448,  422,  469,  469,  469,  449,
      424,  442,  442,  442,  442,  442,  469,  469,  424,  449,
      449,  449,  449,  449,  449,  469,  469,  469,  469,  469,
      443,  469,  469,  469,  469,  469,  454,  469,  469,  469,
      443,  443,  443,  443,  443,  443,  454,  454,  454,  454,
      454,  454,  455,  469,  469,  469,  469,  469,  459,  469,
      469,  469,  455,  455,  455,  455,  455,  455,  459,  459,
      459,  459,  459,  459,  460,  469,  469,  469,  469,  469,
      423,  469,  469,  469,  460,  460,  460,  460,  460,  460,

      423,  423,  423,  423,  423,  423,  463,  469,  469,  469,
      469,  469,  423,  469,  469,  469,  463,  463,  463,  463,
      463,  463,  423,  423,  423,  423,  423,  423,   39,  469,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   45,
       45,  469,   45,   45,   48,  469,   48,   48,   48,   48,
       48,   48,   48,   48,   48,   54,   54,  469,   54,   54,
       81,  469,  469,   81,   81,   88,   88,   88,   88,   88,
       88,   88,   88,   88,   92,  469,   92,   92,  469,   92,
       92,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  112,  112,  112,  112,  112,  112,  112,  112,

      112,  114,  114,  469,  114,  114,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  125,  125,  125,
      125,  125,  125,  125,  125,  125,  125,  125,  125,   65,
       65,  127,  127,  127,  127,  127,  127,  127,  127,  127,
      129,  129,  469,  129,  129,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  151,  151,  469,  151,  151,  160,
      160,  160,  160,  160,  160,  160,  160,  160,  177,  177,
      177,  177,  177,  177,  177,  177,  177,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  183,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  197,  197,

      197,  197,  197,  197,  197,  197,  197,  209,  209,  209,
      469,  209,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  240,  240,  240,  469,  240,  245,
      245,  245,  245,  469,  245,  245,  245,  245,  245,  245,
      272,  272,  272,  469,  272,  278,  469,  278,  278,  278,
      278,  278,  278,  278,  278,  278,  281,  469,  281,  281,
      281,  281,  281,  281,  281,  281,  281,  284,  284,  284,
      284,  284,  284,  284,  284,  284,  284,  284,  309,  309,
      309,  469,  309,  318,  318,  318,  318,  318,  318,  318,
      318,  318,  318,  318,  323,  323,  323,  323,  323,  323,

      323,  323,  323,  323,  323,  344,  344,  344,  469,  344,
      410,  410,  410,  469,  469,  469,  410,  469,  469,  410,
      410,  419,  419,  419,  419,  419,  419,  419,  419,  419,
      423,  423,  423,  469,  469,  423,  423,  423,  469,  423,
      423,  434,  434,  434,  434,  434,  434,  434,  434,  434,
        7,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,

      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469
    } ;

static yyconst flex_int16_t yy_chk[2412] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        3,  133,    4,    9,    9,    9,    9,    9,   12,    3,
      133,    4,   10,   10,   10,   10,   10,   11,   11,   11,
       11,   11,    3,    3,    4,    4,   13,   67,   12,   13,
       15,   39,   52,   25,   67,    3,   13,    4,   31,   13,

       13,   13,   13,   13,   13,   15,   17,   25,   22,   17,
       27,   39,   31,   27,   11,   52,   17,   26,   22,   69,
       26,   26,   71,   22,   27,   48,   22,   42,   31,   22,
       42,   26,   17,   22,   22,  154,   22,   42,   71,   69,
       48,   17,   20,   23,   27,   64,   54,   64,   26,   20,
       20,  154,   20,   23,   23,   23,   23,   23,   23,   20,
       54,   20,   20,   20,   20,   20,   20,   20,   20,   20,
       20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
       20,   20,   20,   20,   20,   20,   20,   20,   33,   32,
       35,   20,   32,   32,   36,   36,   36,   36,   36,   57,

       43,   57,   33,   32,   35,   37,   37,   37,   37,   37,
       43,   43,   43,   43,   43,   43,   44,   83,   33,   55,
       32,   35,   55,   55,   57,   46,   44,   44,   44,   44,
       44,   44,   46,   55,   83,   46,   46,   46,   46,   46,
       46,   53,   37,   41,   41,   41,   41,   56,   66,   41,
       72,   53,   53,   53,   53,   53,   53,   70,  146,   85,
       72,   56,   41,   66,  146,   75,   85,   68,   56,   41,
       75,   73,   41,   41,   41,   41,   41,   41,   49,   49,
       49,   49,   68,   74,   74,   70,   73,   75,   63,   49,
      468,   75,   73,   68,   74,   79,   82,   49,   63,   63,

       63,   63,   63,   63,   49,   79,   82,   49,   49,   49,
       49,   49,   49,   76,   80,   86,   76,   84,   86,   87,
       88,  131,   87,  107,   80,   80,   80,   80,   80,   80,
       79,   92,   84,  108,   88,   89,   89,   89,   89,   89,
      131,   95,   96,  107,  102,   92,  156,   89,   95,   98,
      123,  123,  156,  108,   89,   95,   96,  139,  102,  136,
       93,   89,  136,   98,   89,   89,   89,   89,   89,   89,
       93,   93,   93,   93,   93,   93,   97,   98,   96,  101,
      102,   97,  103,  104,  117,  139,   97,   97,   97,   97,
       97,   97,  111,  101,  117,  106,  103,  104,  232,  101,

      106,  115,  111,  111,  111,  111,  111,  111,  232,  117,
      103,  115,  115,  115,  115,  115,  115,  104,  116,  118,
      106,  109,  109,  109,  109,  109,  119,  109,  116,  116,
      116,  116,  116,  116,  118,  126,  142,  148,  461,  126,
      109,  119,  153,  142,  148,  153,  124,  109,  157,  155,
      109,  109,  109,  109,  109,  109,  110,  110,  110,  110,
      124,  158,  110,  157,  124,  165,  130,  155,  190,  160,
      158,  456,  452,  165,  190,  110,  130,  130,  130,  130,
      130,  130,  110,  160,  164,  110,  110,  110,  110,  110,
      110,  113,  113,  113,  113,  113,  436,  202,  164,  188,

      192,  152,  203,  167,  168,  169,  188,  192,  202,  203,
      113,  152,  152,  152,  152,  152,  152,  167,  168,  169,
      113,  113,  113,  113,  113,  113,  120,  120,  120,  120,
      120,  195,  261,  204,  173,  195,  159,  120,  223,  171,
      204,  234,  223,  261,  234,  120,  159,  159,  159,  159,
      159,  159,  120,  171,  173,  120,  120,  120,  120,  120,
      120,  121,  121,  121,  121,  170,  199,  163,  180,  209,
      213,  201,  121,  303,  163,  182,  303,  209,  430,  170,
      121,  163,  200,  180,  213,  233,  199,  121,  201,  182,
      121,  121,  121,  121,  121,  121,  128,  128,  128,  128,

      128,  240,  182,  226,  200,  233,  170,  228,  425,  240,
      212,  212,  212,  212,  212,  128,  212,  415,  226,  231,
      228,  212,  128,  212,  221,  128,  128,  128,  128,  128,
      128,  150,  150,  150,  150,  150,  212,  235,  221,  246,
      231,  174,  305,  340,  379,  305,  381,  379,  340,  221,
      150,  174,  174,  174,  174,  174,  174,  150,  235,  246,
      150,  150,  150,  150,  150,  150,  161,  161,  161,  161,
      161,  380,  264,  265,  272,  309,  175,  366,  247,  264,
      257,  265,  272,  309,  366,  161,  175,  175,  175,  175,
      175,  175,  176,  247,  257,  161,  161,  161,  161,  161,

      161,  266,  176,  176,  176,  176,  176,  176,  178,  178,
      178,  178,  178,  360,  336,  341,  257,  268,  179,  367,
      341,  281,  344,  266,  336,  388,  367,  178,  179,  179,
      179,  179,  179,  179,  181,  268,  281,  178,  178,  178,
      178,  178,  178,  185,  181,  181,  181,  181,  181,  181,
      278,  318,  388,  185,  185,  185,  185,  185,  185,  187,
      187,  187,  187,  187,  277,  277,  277,  277,  277,  196,
      278,  318,  279,  279,  279,  279,  279,  277,  187,  196,
      196,  196,  196,  196,  196,  279,  299,  302,  187,  187,
      187,  187,  187,  187,  198,  198,  198,  198,  198,  315,

      315,  315,  315,  315,  205,  416,  339,  296,  299,  302,
      416,  296,  315,  198,  205,  205,  205,  205,  205,  205,
      206,  296,  323,  198,  198,  198,  198,  198,  198,  208,
      206,  206,  206,  206,  206,  206,  215,  323,  356,  208,
      208,  208,  208,  208,  208,  216,  215,  215,  215,  215,
      215,  215,  217,  356,  357,  216,  216,  216,  216,  216,
      216,  218,  217,  217,  217,  217,  217,  217,  219,  357,
      412,  218,  218,  218,  218,  218,  218,  220,  219,  219,
      219,  219,  219,  219,  224,  328,  412,  220,  220,  220,
      220,  220,  220,  225,  224,  224,  224,  224,  224,  224,

      229,  439,  437,  225,  225,  225,  225,  225,  225,  230,
      229,  229,  229,  229,  229,  229,  237,  437,  439,  230,
      230,  230,  230,  230,  230,  238,  237,  237,  237,  237,
      237,  237,  239,  352,  377,  238,  238,  238,  238,  238,
      238,  362,  239,  239,  239,  239,  239,  239,  244,  244,
      244,  244,  244,  352,  244,  362,  314,  377,  362,  244,
      322,  244,  245,  245,  245,  245,  245,  251,  245,  333,
      322,  317,  373,  245,  244,  245,  317,  251,  251,  251,
      251,  251,  251,  333,  353,  322,  373,  374,  245,  249,
      249,  249,  249,  249,  374,  249,  317,  313,  375,  252,

      249,  249,  249,  386,  353,  375,  373,  333,  249,  252,
      252,  252,  252,  252,  252,  249,  253,  386,  249,  249,
      249,  249,  249,  249,  254,  399,  253,  253,  253,  253,
      253,  253,  255,  399,  254,  254,  254,  254,  254,  254,
      256,  312,  255,  255,  255,  255,  255,  255,  258,  311,
      256,  256,  256,  256,  256,  256,  259,  310,  258,  258,
      258,  258,  258,  258,  262,  304,  259,  259,  259,  259,
      259,  259,  263,  294,  262,  262,  262,  262,  262,  262,
      269,  289,  263,  263,  263,  263,  263,  263,  270,  276,
      269,  269,  269,  269,  269,  269,  271,  376,  270,  270,

      270,  270,  270,  270,  376,  390,  271,  271,  271,  271,
      271,  271,  280,  280,  280,  280,  378,  387,  280,  390,
      431,  391,  387,  378,  431,  387,  283,  283,  283,  283,
      283,  280,  283,  403,  389,  391,  411,  283,  280,  283,
      389,  280,  280,  280,  280,  280,  280,  282,  282,  282,
      282,  275,  283,  397,  392,  440,  403,  411,  282,  284,
      284,  284,  284,  284,  398,  284,  282,  397,  392,  440,
      284,  400,  284,  282,  392,  398,  282,  282,  282,  282,
      282,  282,  400,  404,  401,  284,  285,  285,  285,  285,
      285,  401,  285,  414,  404,  418,  414,  285,  418,  285,

      286,  286,  286,  286,  286,  290,  286,  402,  457,  466,
      274,  286,  285,  286,  402,  290,  290,  290,  290,  290,
      290,  427,  273,  466,  427,  417,  286,  287,  287,  287,
      287,  287,  417,  287,  413,  457,  428,  292,  287,  267,
      287,  330,  330,  330,  330,  330,  287,  292,  292,  292,
      292,  292,  292,  287,  413,  428,  287,  287,  287,  287,
      287,  287,  288,  288,  288,  288,  288,  330,  288,  426,
      444,  445,  293,  288,  288,  288,  426,  444,  445,  260,
      458,  288,  293,  293,  293,  293,  293,  293,  288,  295,
      458,  288,  288,  288,  288,  288,  288,  297,  250,  295,

      295,  295,  295,  295,  295,  298,  243,  297,  297,  297,
      297,  297,  297,  300,  242,  298,  298,  298,  298,  298,
      298,  301,  241,  300,  300,  300,  300,  300,  300,  429,
      446,  301,  301,  301,  301,  301,  301,  306,  306,  306,
      306,  306,  307,  408,  408,  408,  408,  408,  236,  306,
      446,  429,  307,  307,  307,  307,  307,  307,  308,  408,
      447,  451,  227,  306,  222,  438,  214,  447,  308,  308,
      308,  308,  308,  308,  319,  319,  319,  319,  319,  211,
      319,  451,  324,  324,  324,  324,  324,  319,  438,  465,
      462,  464,  210,  324,  465,  324,  462,  197,  464,  327,

      319,  320,  320,  320,  320,  320,  193,  320,  324,  327,
      327,  327,  327,  327,  327,  334,  334,  334,  334,  334,
      320,  337,  337,  337,  337,  337,  191,  320,  450,  189,
      320,  320,  320,  320,  320,  320,  321,  321,  321,  321,
      186,  334,  321,  453,  183,  177,  329,  337,  172,  450,
      361,  361,  361,  361,  361,  321,  329,  329,  329,  329,
      329,  329,  321,  166,  453,  321,  321,  321,  321,  321,
      321,  325,  325,  325,  325,  325,  361,  467,  162,  151,
      149,  331,  325,  147,  363,  363,  363,  363,  363,  145,
      325,  331,  331,  331,  331,  331,  331,  325,  467,  144,

      325,  325,  325,  325,  325,  325,  326,  326,  326,  326,
      363,  421,  421,  421,  421,  421,  332,  326,  143,  141,
      140,  138,  137,  135,  421,  326,  332,  332,  332,  332,
      332,  332,  326,  335,  134,  326,  326,  326,  326,  326,
      326,  338,  132,  335,  335,  335,  335,  335,  335,  129,
      127,  338,  338,  338,  338,  338,  338,  342,  342,  342,
      342,  342,  343,  365,  365,  365,  365,  365,  125,  342,
      114,  112,  343,  343,  343,  343,  343,  343,  351,  351,
      351,  351,  351,  342,  351,  354,  105,   94,   81,  365,
       78,  351,   77,   65,   61,  354,  354,  354,  354,  354,

      354,   60,   59,   58,  351,  355,  355,  355,  355,  355,
      358,   51,   45,   38,   29,   28,  355,   24,  355,   21,
      358,  358,  358,  358,  358,  358,  359,   19,   18,  364,
       16,  355,   14,    7,    6,  364,  359,  359,  359,  359,
      359,  359,  364,    5,  364,  368,    0,    0,    0,  364,
      364,  369,    0,  364,    0,  368,  368,  368,  368,  368,
      368,  369,  369,  369,  369,  369,  369,  370,    0,    0,
        0,    0,    0,  371,    0,    0,    0,  370,  370,  370,
      370,  370,  370,  371,  371,  371,  371,  371,  371,  383,
        0,    0,    0,    0,    0,  384,    0,    0,    0,  383,

      383,  383,  383,  383,  383,  384,  384,  384,  384,  384,
      384,  385,    0,    0,    0,    0,    0,  393,    0,    0,
        0,  385,  385,  385,  385,  385,  385,  393,  393,  393,
      393,  393,  393,  394,    0,    0,    0,    0,    0,  395,
        0,    0,    0,  394,  394,  394,  394,  394,  394,  395,
      395,  395,  395,  395,  395,  396,  396,  396,  396,  396,
        0,    0,  405,    0,    0,    0,    0,    0,    0,    0,
        0,  396,  405,  405,  405,  405,  405,  405,  406,    0,
        0,  396,  407,  407,  407,  407,  407,    0,  406,  406,
      406,  406,  406,  406,    0,    0,    0,    0,  407,  409,

        0,    0,  410,  410,  410,  410,  410,    0,  407,  409,
      409,  409,  409,  409,  409,  410,  419,  419,  419,  419,
      419,    0,  423,  423,  423,  423,  423,    0,  410,  419,
        0,    0,    0,    0,    0,  423,    0,    0,    0,  424,
        0,    0,  419,  420,  420,  420,  420,  420,  423,  424,
      424,  424,  424,  424,  424,    0,  420,  432,  432,  432,
      432,  432,  420,    0,    0,    0,    0,    0,    0,  420,
      432,    0,  420,  420,  420,  420,  420,  420,  433,    0,
        0,    0,    0,  432,    0,    0,    0,    0,  433,  433,
      433,  433,  433,  433,  434,  434,  434,  434,  434,  441,

        0,    0,  442,  442,  442,  442,  442,  434,    0,  441,
      441,  441,  441,  441,  441,  442,    0,    0,    0,  443,
      434,  435,  435,  435,  435,  435,    0,    0,  442,  443,
      443,  443,  443,  443,  443,    0,    0,    0,    0,    0,
      435,    0,    0,    0,    0,    0,  448,    0,    0,    0,
      435,  435,  435,  435,  435,  435,  448,  448,  448,  448,
      448,  448,  449,    0,    0,    0,    0,    0,  454,    0,
        0,    0,  449,  449,  449,  449,  449,  449,  454,  454,
      454,  454,  454,  454,  455,    0,    0,    0,    0,    0,
      459,    0,    0,    0,  455,  455,  455,  455,  455,  455,

      459,  459,  459,  459,  459,  459,  460,    0,    0,    0,
        0,    0,  463,    0,    0,    0,  460,  460,  460,  460,
      460,  460,  463,  463,  463,  463,  463,  463,  470,    0,
      470,  470,  470,  470,  470,  470,  470,  470,  470,  471,
      471,    0,  471,  471,  472,    0,  472,  472,  472,  472,
      472,  472,  472,  472,  472,  473,  473,    0,  473,  473,
      474,    0,    0,  474,  474,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  476,    0,  476,  476,    0,  476,
      476,  477,  477,  477,  477,  477,  477,  477,  477,  477,
      477,  477,  478,  478,  478,  478,  478,  478,  478,  478,

      478,  479,  479,    0,  479,  479,  480,  480,  480,  480,
      480,  480,  480,  480,  480,  480,  480,  481,  481,  481,
      481,  481,  481,  481,  481,  481,  481,  481,  481,  482,
      482,  483,  483,  483,  483,  483,  483,  483,  483,  483,
      484,  484,    0,  484,  484,  485,  485,  485,  485,  485,
      485,  485,  485,  485,  486,  486,    0,  486,  486,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  488,  488,
      488,  488,  488,  488,  488,  488,  488,  489,  489,  489,
      489,  489,  489,  489,  489,  489,  489,  489,  489,  490,
      490,  490,  490,  490,  490,  490,  490,  490,  491,  491,

      491,  491,  491,  491,  491,  491,  491,  492,  492,  492,
        0,  492,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  494,  494,  494,    0,  494,  495,
      495,  495,  495,    0,  495,  495,  495,  495,  495,  495,
      496,  496,  496,    0,  496,  497,    0,  497,  497,  497,
      497,  497,  497,  497,  497,  497,  498,    0,  498,  498,
      498,  498,  498,  498,  498,  498,  498,  499,  499,  499,
      499,  499,  499,  499,  499,  499,  499,  499,  500,  500,
      500,    0,  500,  501,  501,  501,  501,  501,  501,  501,
      501,  501,  501,  501,  502,  502,  502,  502,  502,  502,

      502,  502,  502,  502,  502,  503,  503,  503,    0,  503,
      504,  504,  504,    0,    0,    0,  504,    0,    0,  504,
      504,  505,  505,  505,  505,  505,  505,  505,  505,  505,
      506,  506,  506,    0,    0,  506,  506,  506,    0,  506,
      506,  507,  507,  507,  507,  507,  507,  507,  507,  507,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,

      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469
    } ;

#line 1 "WebCore/css/tokenizer.flex"
YY_DECL
{
	register yy_state_type yy_current_state;
	register UChar *yy_cp, *yy_bp;
	register int yy_act;
	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 470 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2351 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 31 "WebCore/css/tokenizer.flex"
/* ignore comments */
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 33 "WebCore/css/tokenizer.flex"
{yyTok = WHITESPACE; return yyTok;}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 35 "WebCore/css/tokenizer.flex"
{yyTok = SGML_CD; return yyTok;}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 36 "WebCore/css/tokenizer.flex"
{yyTok = SGML_CD; return yyTok;}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 37 "WebCore/css/tokenizer.flex"
{yyTok = INCLUDES; return yyTok;}
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 38 "WebCore/css/tokenizer.flex"
{yyTok = DASHMATCH; return yyTok;}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 39 "WebCore/css/tokenizer.flex"
{yyTok = BEGINSWITH; return yyTok;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 40 "WebCore/css/tokenizer.flex"
{yyTok = ENDSWITH; return yyTok;}
	YY_BREAK
case 9:
YY_RULE_SETUP
#line 41 "WebCore/css/tokenizer.flex"
{yyTok = CONTAINS; return yyTok;}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 42 "WebCore/css/tokenizer.flex"
{yyTok = MEDIA_NOT; return yyTok;}
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 43 "WebCore/css/tokenizer.flex"
{yyTok = MEDIA_ONLY; return yyTok;}
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 44 "WebCore/css/tokenizer.flex"
{yyTok = MEDIA_AND; return yyTok;}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 45 "WebCore/css/tokenizer.flex"
{BEGIN(mediaquery); yyTok = VARIABLES_FOR; return yyTok; }
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 47 "WebCore/css/tokenizer.flex"
{yyTok = STRING; return yyTok;}
	YY_BREAK
case 15:
/* rule 15 can match eol */
YY_RULE_SETUP
#line 48 "WebCore/css/tokenizer.flex"
{yyTok = IDENT; return yyTok;}
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 49 "WebCore/css/tokenizer.flex"
{yyTok = NTH; return yyTok;}
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 51 "WebCore/css/tokenizer.flex"
{yyTok = HEX; return yyTok;}
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 52 "WebCore/css/tokenizer.flex"
{yyTok = IDSEL; return yyTok;}
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 54 "WebCore/css/tokenizer.flex"
{BEGIN(mediaquery); yyTok = IMPORT_SYM; return yyTok;}
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 55 "WebCore/css/tokenizer.flex"
{yyTok = PAGE_SYM; return yyTok;}
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 56 "WebCore/css/tokenizer.flex"
{BEGIN(mediaquery); yyTok = MEDIA_SYM; return yyTok;}
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 57 "WebCore/css/tokenizer.flex"
{yyTok = FONT_FACE_SYM; return yyTok;}
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 58 "WebCore/css/tokenizer.flex"
{yyTok = CHARSET_SYM; return yyTok;}
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 59 "WebCore/css/tokenizer.flex"
{yyTok = NAMESPACE_SYM; return yyTok; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 60 "WebCore/css/tokenizer.flex"
{yyTok = WEBKIT_RULE_SYM; return yyTok; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 61 "WebCore/css/tokenizer.flex"
{yyTok = WEBKIT_DECLS_SYM; return yyTok; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 62 "WebCore/css/tokenizer.flex"
{yyTok = WEBKIT_VALUE_SYM; return yyTok; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 63 "WebCore/css/tokenizer.flex"
{BEGIN(mediaquery); yyTok = WEBKIT_MEDIAQUERY_SYM; return yyTok; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 64 "WebCore/css/tokenizer.flex"
{yyTok = WEBKIT_SELECTOR_SYM; return yyTok; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 65 "WebCore/css/tokenizer.flex"
{BEGIN(mediaquery); yyTok = WEBKIT_VARIABLES_SYM; return yyTok; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 66 "WebCore/css/tokenizer.flex"
{BEGIN(forkeyword); yyTok = WEBKIT_DEFINE_SYM; return yyTok; }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 67 "WebCore/css/tokenizer.flex"
{ yyTok = WEBKIT_VARIABLES_DECLS_SYM; return yyTok; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 68 "WebCore/css/tokenizer.flex"
{yyTok = WEBKIT_KEYFRAMES_SYM; return yyTok; }
	YY_BREAK
case 34:
/* rule 34 can match eol */
YY_RULE_SETUP
#line 70 "WebCore/css/tokenizer.flex"
{yyTok = ATKEYWORD; return yyTok; }
	YY_BREAK
case 35:
/* rule 35 can match eol */
YY_RULE_SETUP
#line 72 "WebCore/css/tokenizer.flex"
{yyTok = IMPORTANT_SYM; return yyTok;}
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 74 "WebCore/css/tokenizer.flex"
{yyTok = EMS; return yyTok;}
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 75 "WebCore/css/tokenizer.flex"
{yyTok = QEMS; return yyTok;} /* quirky ems */
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 76 "WebCore/css/tokenizer.flex"
{yyTok = EXS; return yyTok;}
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 77 "WebCore/css/tokenizer.flex"
{yyTok = PXS; return yyTok;}
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 78 "WebCore/css/tokenizer.flex"
{yyTok = CMS; return yyTok;}
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 79 "WebCore/css/tokenizer.flex"
{yyTok = MMS; return yyTok;}
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 80 "WebCore/css/tokenizer.flex"
{yyTok = INS; return yyTok;}
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 81 "WebCore/css/tokenizer.flex"
{yyTok = PTS; return yyTok;}
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 82 "WebCore/css/tokenizer.flex"
{yyTok = PCS; return yyTok;}
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 83 "WebCore/css/tokenizer.flex"
{yyTok = DEGS; return yyTok;}
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 84 "WebCore/css/tokenizer.flex"
{yyTok = RADS; return yyTok;}
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 85 "WebCore/css/tokenizer.flex"
{yyTok = GRADS; return yyTok;}
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 86 "WebCore/css/tokenizer.flex"
{yyTok = MSECS; return yyTok;}
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 87 "WebCore/css/tokenizer.flex"
{yyTok = SECS; return yyTok;}
	YY_BREAK
case 50:
YY_RULE_SETUP
#line 88 "WebCore/css/tokenizer.flex"
{yyTok = HERZ; return yyTok;}
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 89 "WebCore/css/tokenizer.flex"
{yyTok = KHERZ; return yyTok;}
	YY_BREAK
case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 90 "WebCore/css/tokenizer.flex"
{yyTok = DIMEN; return yyTok;}
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 91 "WebCore/css/tokenizer.flex"
{yyTok = PERCENTAGE; return yyTok;}
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 92 "WebCore/css/tokenizer.flex"
{yyTok = INTEGER; return yyTok;}
	YY_BREAK
case 55:
YY_RULE_SETUP
#line 93 "WebCore/css/tokenizer.flex"
{yyTok = FLOATTOKEN; return yyTok;}
	YY_BREAK
case 56:
YY_RULE_SETUP
#line 95 "WebCore/css/tokenizer.flex"
{yyTok = NOTFUNCTION; return yyTok;}
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
#line 96 "WebCore/css/tokenizer.flex"
{yyTok = URI; return yyTok;}
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 97 "WebCore/css/tokenizer.flex"
{yyTok = URI; return yyTok;}
	YY_BREAK
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 98 "WebCore/css/tokenizer.flex"
{ yyTok = VARCALL; return yyTok; }
	YY_BREAK
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 99 "WebCore/css/tokenizer.flex"
{yyTok = FUNCTION; return yyTok;}
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 101 "WebCore/css/tokenizer.flex"
{yyTok = UNICODERANGE; return yyTok;}
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 102 "WebCore/css/tokenizer.flex"
{yyTok = UNICODERANGE; return yyTok;}
	YY_BREAK
case 63:
#line 105 "WebCore/css/tokenizer.flex"
case 64:
YY_RULE_SETUP
#line 105 "WebCore/css/tokenizer.flex"
{BEGIN(INITIAL); yyTok = *yytext; return yyTok; }
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 106 "WebCore/css/tokenizer.flex"
{yyTok = *yytext; return yyTok;}
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 108 "WebCore/css/tokenizer.flex"
ECHO;
	YY_BREAK
#line 1743 "<stdout>"
case YY_STATE_EOF(INITIAL):
case YY_END_OF_BUFFER:
case YY_STATE_EOF(mediaquery):
case YY_STATE_EOF(forkeyword):
	yyterminate();

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */
